Index: trunk/SophyaLib/NTools/cimage.cc
===================================================================
--- trunk/SophyaLib/NTools/cimage.cc	(revision 2884)
+++ trunk/SophyaLib/NTools/cimage.cc	(revision 2885)
@@ -101,6 +101,6 @@
   : FIO_TArray<T>()
 { 
-  dobj = new Image<T>(obj, true);
-  ownobj=true; 
+  this->dobj = new Image<T>(obj, true);
+  this->ownobj=true; 
 }
 
@@ -124,6 +124,6 @@
     throw TypeMismatchExc(PExcLongMessage(buff));        
   }
-  if (ownobj && dobj) delete dobj;
-  dobj = po; ownobj = false;
+  if (this->ownobj && this->dobj) delete this->dobj;
+  this->dobj = po; this->ownobj = false;
 } 
 
@@ -131,6 +131,6 @@
 void FIO_Image<T>::ReadSelf(PInPersist& is)
 {
-  if (dobj == NULL) dobj = new Image<T>;
-  Image<T> * img = dynamic_cast<Image<T> * > (dobj);
+  if (this->dobj == NULL) this->dobj = new Image<T>;
+  Image<T> * img = dynamic_cast<Image<T> * > (this->dobj);
 // On lit les 3 premiers uint_4
 //  0: Numero de version,  1 : reserve
@@ -155,6 +155,6 @@
 void FIO_Image<T>::WriteSelf(POutPersist& os) const
 {
-  if (dobj == NULL)   return;
-  Image<T> * img = dynamic_cast<Image<T> * > (dobj);
+  if (this->dobj == NULL)   return;
+  Image<T> * img = dynamic_cast<Image<T> * > (this->dobj);
 //  On ecrit 3 uint_4 .... 
   uint_4 itab[3];
Index: trunk/SophyaLib/NTools/cimage.h
===================================================================
--- trunk/SophyaLib/NTools/cimage.h	(revision 2884)
+++ trunk/SophyaLib/NTools/cimage.h	(revision 2885)
@@ -33,7 +33,7 @@
 
   //! Returns the image size along X (corresponding to the number of columns)  
-  inline sa_size_t  XSize() const {return NCols();}
+  inline sa_size_t  XSize() const {return this->NCols();}
   //! Returns the image size along Y (corresponding to the number of lines)  
-  inline sa_size_t  YSize() const {return NRows();}
+  inline sa_size_t  YSize() const {return this->NRows();}
 
   //! Returns the X position, for pixel(0,0)
@@ -89,5 +89,5 @@
   //  virtual ~FIO_Image();  
   virtual void        SetDataObj(AnyDataObj & o);
-  inline operator Image<T>() { return(*(dynamic_cast<Image<T> * >(dobj))); }
+  inline operator Image<T>() { return(*(dynamic_cast<Image<T> * >(this->dobj))); }
 protected :
   virtual void ReadSelf(PInPersist&);           
Index: trunk/SophyaLib/Samba/alm.cc
===================================================================
--- trunk/SophyaLib/Samba/alm.cc	(revision 2884)
+++ trunk/SophyaLib/Samba/alm.cc	(revision 2885)
@@ -22,5 +22,5 @@
 
   //alm.ReSize(nlmax);
-  ReSizeRow(nlmax+1);
+  this->ReSizeRow(nlmax+1);
 
   r_8 sig_smooth = fwhm/sqrt(8.*log(2.))/(60.*180.)* M_PI;
Index: trunk/SophyaLib/Samba/alm.h
===================================================================
--- trunk/SophyaLib/Samba/alm.h	(revision 2884)
+++ trunk/SophyaLib/Samba/alm.h	(revision 2885)
@@ -26,6 +26,6 @@
 Alm(const TVector<T>& clin, const r_8 fwhm) ;
 /*! resize with a new lmax */
-inline void ReSizeToLmax(int_4 nlmax) {ReSizeRow(nlmax+1);}
-inline int_4 Lmax() const {return rowNumber()-1;}
+inline void ReSizeToLmax(int_4 nlmax) {this->ReSizeRow(nlmax+1);}
+inline int_4 Lmax() const {return this->rowNumber()-1;}
 TVector<T> powerSpectrum() const;
 
Index: trunk/SophyaLib/SkyMap/localmap.cc
===================================================================
--- trunk/SophyaLib/SkyMap/localmap.cc	(revision 2884)
+++ trunk/SophyaLib/SkyMap/localmap.cc	(revision 2885)
@@ -181,5 +181,5 @@
 {
 
-  if(lm.mInfo_) mInfo_= new DVList(*lm.mInfo_);
+  if(lm.mInfo_) this->mInfo_= new DVList(*lm.mInfo_);
   recopierVariablesSimples(lm);
 }
@@ -196,5 +196,5 @@
 {
 
-  if(lm.mInfo_) mInfo_= new DVList(*lm.mInfo_);
+  if(lm.mInfo_) this->mInfo_= new DVList(*lm.mInfo_);
   recopierVariablesSimples(lm);
 }
@@ -236,6 +236,6 @@
       recopierVariablesSimples(a);     
       pixels_.CloneOrShare(a.pixels_);
-      if (mInfo_) {delete mInfo_; mInfo_ = NULL;}
-      if (a.mInfo_) mInfo_ = new DVList(*(a.mInfo_));
+      if (this->mInfo_) {delete this->mInfo_; this->mInfo_ = NULL;}
+      if (a.mInfo_) this->mInfo_ = new DVList(*(a.mInfo_));
 }
 template<class T>
@@ -244,6 +244,6 @@
       recopierVariablesSimples(a);     
       pixels_.Share(a.pixels_);
-      if (mInfo_) {delete mInfo_; mInfo_ = NULL;}
-      if (a.mInfo_) mInfo_ = new DVList(*(a.mInfo_));
+      if (this->mInfo_) {delete this->mInfo_; this->mInfo_ = NULL;}
+      if (a.mInfo_) this->mInfo_ = new DVList(*(a.mInfo_));
 }
 
@@ -271,7 +271,7 @@
       if (NbPixels() < 1) CloneOrShare(a);
       else CopyElt(a);
-      if (mInfo_) delete mInfo_;
-      mInfo_ = NULL;
-      if (a.mInfo_) mInfo_ = new DVList(*(a.mInfo_));
+      if (this->mInfo_) delete this->mInfo_;
+      this->mInfo_ = NULL;
+      if (a.mInfo_) this->mInfo_ = new DVList(*(a.mInfo_));
     }
   return(*this);
Index: trunk/SophyaLib/SkyMap/localmap.h
===================================================================
--- trunk/SophyaLib/SkyMap/localmap.h	(revision 2884)
+++ trunk/SophyaLib/SkyMap/localmap.h	(revision 2885)
@@ -54,12 +54,12 @@
 // ---------- Overloading of () to access pixel number k ----
 
-inline T& operator()(int_4 k) {return(PixVal(k));}
-inline T const& operator()(int_4 k) const {return(PixVal(k));}
-inline T& operator()(int_4 ix, int_4 iy) {return PixVal(iy*nSzX_+ix);};
-inline T const& operator()(int_4 ix, int_4 iy) const {return PixVal(iy*nSzX_+ix);};
+inline T& operator()(int_4 k) {return(this->PixVal(k));}
+inline T const& operator()(int_4 k) const {return(this->PixVal(k));}
+inline T& operator()(int_4 ix, int_4 iy) {return this->PixVal(iy*nSzX_+ix);};
+inline T const& operator()(int_4 ix, int_4 iy) const {return this->PixVal(iy*nSzX_+ix);};
 
 // Acces a un pixel 
-inline T& operator()(double theta,double phi) {return(PixValSph(theta,phi));};
-inline T  const& operator()(double theta,double phi) const {return(PixValSph(theta,phi));};
+inline T& operator()(double theta,double phi) {return(this->PixValSph(theta,phi));};
+inline T  const& operator()(double theta,double phi) const {return(this->PixValSph(theta,phi));};
    
 // ---------- Definition of PixelMap abstract methods -------
Index: trunk/SophyaLib/SkyMap/spherehealpix.cc
===================================================================
--- trunk/SophyaLib/SkyMap/spherehealpix.cc	(revision 2884)
+++ trunk/SophyaLib/SkyMap/spherehealpix.cc	(revision 2885)
@@ -113,5 +113,5 @@
   nPix_ = s.nPix_;
   omeg_ = s.omeg_;
-  if(s.mInfo_) mInfo_= new DVList(*s.mInfo_);
+  if(s.mInfo_) this->mInfo_= new DVList(*s.mInfo_);
 }
 //++
@@ -126,5 +126,5 @@
   nPix_ = s.nPix_;
   omeg_ = s.omeg_;
-  if(s.mInfo_) mInfo_= new DVList(*s.mInfo_);
+  if(s.mInfo_) this->mInfo_= new DVList(*s.mInfo_);
   //  CloneOrShare(s);
 }
@@ -141,6 +141,6 @@
   sliceBeginIndex_.CloneOrShare(a.sliceBeginIndex_);
   sliceLenght_.CloneOrShare(a.sliceLenght_);
-  if (mInfo_) {delete mInfo_; mInfo_ = NULL;}
-  if (a.mInfo_) mInfo_ = new DVList(*(a.mInfo_));
+  if (this->mInfo_) {delete this->mInfo_; this->mInfo_ = NULL;}
+  if (a.mInfo_) this->mInfo_ = new DVList(*(a.mInfo_));
 }
 
@@ -155,6 +155,6 @@
   sliceBeginIndex_.Share(a.sliceBeginIndex_);
   sliceLenght_.Share(a.sliceLenght_);
-  if (mInfo_) {delete mInfo_; mInfo_ = NULL;}
-  if (a.mInfo_) mInfo_ = new DVList(*(a.mInfo_));
+  if (this->mInfo_) {delete this->mInfo_; this->mInfo_ = NULL;}
+  if (a.mInfo_) this->mInfo_ = new DVList(*(a.mInfo_));
 }
 
@@ -172,7 +172,7 @@
       
       
-      if (mInfo_) delete mInfo_;
-      mInfo_ = NULL;
-      if (a.mInfo_) mInfo_ = new DVList(*(a.mInfo_));
+      if (this->mInfo_) delete this->mInfo_;
+      this->mInfo_ = NULL;
+      if (a.mInfo_) this->mInfo_ = new DVList(*(a.mInfo_));
     }
   return(*this);
@@ -674,5 +674,5 @@
 void SphereHEALPix<T>::print(ostream& os) const
 {
-  if(mInfo_) os << "  DVList Info= " << *mInfo_ << endl;
+  if(this->mInfo_) os << "  DVList Info= " << *(this->mInfo_) << endl;
   //
   os << " nSide_ = " << nSide_  << endl;
Index: trunk/SophyaLib/SkyMap/spherethetaphi.cc
===================================================================
--- trunk/SophyaLib/SkyMap/spherethetaphi.cc	(revision 2884)
+++ trunk/SophyaLib/SkyMap/spherethetaphi.cc	(revision 2885)
@@ -81,5 +81,5 @@
   NPix_  = s.NPix_;
   Omega_ = s.Omega_;
-  if(s.mInfo_) mInfo_= new DVList(*s.mInfo_);
+  if(s.mInfo_) this->mInfo_= new DVList(*s.mInfo_);
 }
 
@@ -92,5 +92,5 @@
   NPix_  = s.NPix_;
   Omega_ = s.Omega_;
-  if(s.mInfo_) mInfo_= new DVList(*s.mInfo_);
+  if(s.mInfo_) this->mInfo_= new DVList(*s.mInfo_);
 }
 
@@ -139,6 +139,6 @@
   Theta_.CloneOrShare(a.Theta_);
   pixels_.CloneOrShare(a.pixels_);
-  if (mInfo_) {delete mInfo_; mInfo_ = NULL;}
-  if (a.mInfo_) mInfo_ = new DVList(*(a.mInfo_));
+  if (this->mInfo_) {delete this->mInfo_; this->mInfo_ = NULL;}
+  if (a.mInfo_) this->mInfo_ = new DVList(*(a.mInfo_));
 }
 template<class T>
@@ -153,6 +153,6 @@
   Theta_.Share(a.Theta_);
   pixels_.Share(a.pixels_);
-  if (mInfo_) {delete mInfo_; mInfo_ = NULL;}
-  if (a.mInfo_) mInfo_ = new DVList(*(a.mInfo_));
+  if (this->mInfo_) {delete this->mInfo_; this->mInfo_ = NULL;}
+  if (a.mInfo_) this->mInfo_ = new DVList(*(a.mInfo_));
 }
 
@@ -169,7 +169,7 @@
       if (NbPixels() < 1) CloneOrShare(a);
       else CopyElt(a);
-      if (mInfo_) delete mInfo_;
-      mInfo_ = NULL;
-      if (a.mInfo_) mInfo_ = new DVList(*(a.mInfo_));
+      if (this->mInfo_) delete this->mInfo_;
+      this->mInfo_ = NULL;
+      if (a.mInfo_) this->mInfo_ = new DVList(*(a.mInfo_));
     }
   return(*this);
@@ -697,5 +697,5 @@
 void SphereThetaPhi<T>::print(ostream& os) const
 {
-  if(mInfo_) os << "  DVList Info= " << *mInfo_ << endl;
+  if(this->mInfo_) os << "  DVList Info= " << *(this->mInfo_) << endl;
   //
   os << " NTheta_= " << NTheta_ << endl;
Index: trunk/SophyaLib/SkyMap/sphericalmap.h
===================================================================
--- trunk/SophyaLib/SkyMap/sphericalmap.h	(revision 2884)
+++ trunk/SophyaLib/SkyMap/sphericalmap.h	(revision 2885)
@@ -38,8 +38,8 @@
 
 // Overloading of () to access pixel number k.
-inline T& operator()(int k) {return(PixVal(k));}
-inline T  const& operator()(int k) const {return(PixVal(k));}
-inline T& operator()(double theta,double phi) {return(PixValSph(theta,phi));};
-inline T  const& operator()(double theta,double phi) const {return(PixValSph(theta,phi));};
+inline T& operator()(int k) {return(this->PixVal(k));}
+inline T  const& operator()(int k) const {return(this->PixVal(k));}
+inline T& operator()(double theta,double phi) {return(this->PixValSph(theta,phi));};
+inline T  const& operator()(double theta,double phi) const {return(this->PixValSph(theta,phi));};
 
 // index characterizing the size pixelization : m for SphereThetaPhi