Index: trunk/SophyaLib/TArray/smakefile
===================================================================
--- trunk/SophyaLib/TArray/smakefile	(revision 2765)
+++ trunk/SophyaLib/TArray/smakefile	(revision 2909)
@@ -4,8 +4,8 @@
  
 clean:
-	 rm -f $(SOPHYAOBJP)basarr.o $(SOPHYAOBJP)fioarr.o $(SOPHYAOBJP)matharr.o $(SOPHYAOBJP)sopemtx.o $(SOPHYAOBJP)tarray.o $(SOPHYAOBJP)tarrinit.o $(SOPHYAOBJP)tmatrix.o $(SOPHYAOBJP)toeplitzMatrix.o $(SOPHYAOBJP)tvector.o $(SOPHYAOBJP)utilarr.o
+	 rm -f $(SOPHYAOBJP)basarr.o $(SOPHYAOBJP)fioarr.o $(SOPHYAOBJP)matharr.o $(SOPHYAOBJP)sopemtx.o $(SOPHYAOBJP)tarray.o $(SOPHYAOBJP)tarrinit.o $(SOPHYAOBJP)tmatrix.o $(SOPHYAOBJP)tvector.o $(SOPHYAOBJP)utilarr.o
 	rm -f $(SOPHYALIBP)libTArray.a
  
-$(SOPHYALIBP)libTArray.a : $(SOPHYAOBJP)basarr.o $(SOPHYAOBJP)fioarr.o $(SOPHYAOBJP)matharr.o $(SOPHYAOBJP)sopemtx.o $(SOPHYAOBJP)tarray.o $(SOPHYAOBJP)tarrinit.o $(SOPHYAOBJP)tmatrix.o $(SOPHYAOBJP)toeplitzMatrix.o $(SOPHYAOBJP)tvector.o $(SOPHYAOBJP)utilarr.o
+$(SOPHYALIBP)libTArray.a : $(SOPHYAOBJP)basarr.o $(SOPHYAOBJP)fioarr.o $(SOPHYAOBJP)matharr.o $(SOPHYAOBJP)sopemtx.o $(SOPHYAOBJP)tarray.o $(SOPHYAOBJP)tarrinit.o $(SOPHYAOBJP)tmatrix.o $(SOPHYAOBJP)tvector.o $(SOPHYAOBJP)utilarr.o
 	$(AR) $(ARFLAGS) $@ $? 
 	touch $(SOPHYAINCP)/SophyaConfInfo/libsophya.objlist
@@ -16,5 +16,5 @@
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
@@ -22,5 +22,6 @@
   $(SOPHYAINCP)ppfbinstream.h \
   $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  basarr.cc
  
@@ -37,7 +38,9 @@
   $(SOPHYAINCP)anydataobj.h fioarr.h tarray.h \
   basarr.h $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h utilarr.h tmatrix.h \
-  tvector.h $(SOPHYAINCP)datatype.h
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)dvlist.h utilarr.h tmatrix.h \
+  tmatrix_tsnl.h tvector.h tvector_tsnl.h \
+  $(SOPHYAINCP)datatype.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fioarr.cc
  
@@ -46,5 +49,5 @@
   basarr.h $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
@@ -54,4 +57,5 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  matharr.cc
@@ -61,5 +65,5 @@
   tarray.h basarr.h $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
@@ -69,6 +73,8 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h \
-  tvector.h $(SOPHYAINCP)smathconst.h
+  tmatrix_tsnl.h tvector.h tvector_tsnl.h \
+  $(SOPHYAINCP)smathconst.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sopemtx.cc
  
@@ -78,5 +84,5 @@
   basarr.h $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
@@ -85,4 +91,5 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tarray.cc
@@ -94,5 +101,5 @@
   basarr.h $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
@@ -102,6 +109,7 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)ndatablock.h utilarr.h \
-  tmatrix.h tvector.h
+  tmatrix.h tmatrix_tsnl.h tvector.h tvector_tsnl.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tarrinit.cc
  
@@ -111,5 +119,5 @@
   tarray.h basarr.h $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
@@ -118,30 +126,8 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h utilarr.h \
+  tmatrix_tsnl.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmatrix.cc
- 
-$(SOPHYAOBJP)toeplitzMatrix.o: toeplitzMatrix.cc \
-  $(SOPHYAINCP)sopnamsp.h toeplitzMatrix.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)nbmath.h \
-  $(SOPHYAINCP)smathconst.h \
-  $(SOPHYAINCP)timing.h array.h tarray.h \
-  basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h \
-  tmatrix.h tvector.h matharr.h fioarr.h sopemtx.h \
-  $(SOPHYAINCP)fftservintf.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)fftpserver.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  toeplitzMatrix.cc
  
 $(SOPHYAOBJP)tvector.o: tvector.cc $(SOPHYAINCP)sopnamsp.h \
@@ -151,5 +137,5 @@
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)timestamp.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
@@ -158,5 +144,7 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h utilarr.h \
+  tmatrix_tsnl.h tvector_tsnl.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tvector.cc
  
@@ -164,4 +152,13 @@
   $(SOPHYAINCP)machdefs.h utilarr.h \
   $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
   $(SOPHYAINCP)srandgen.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  utilarr.cc