Index: trunk/SophyaLib/BuildMgr/AIX_xlC_make.inc
===================================================================
--- trunk/SophyaLib/BuildMgr/AIX_xlC_make.inc	(revision 2909)
+++ trunk/SophyaLib/BuildMgr/AIX_xlC_make.inc	(revision 2910)
@@ -51,4 +51,8 @@
 
 # --- Chemin pour l ensemble les librairies SOPHYA , +ExtLibs, +PI
+SOPHYALIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST)  $(SOPBASELIBS)
+SOPHYAEXTLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPEXTLIBS) $(SOPBASELIBS)
+SOPHYAALLLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPPILIBLIST) $(PILIBS) $(SOPEXTLIBS) $(SOPBASELIBS)
+
 SOPHYASLBLIST = -L$(SOPHYASLBP) -lsophya  $(SOPBASELIBS)
 SOPHYAEXTSLBLIST = -L$(SOPHYASLBP) -lextsophya -lsophya $(SOPEXTLIBS) $(SOPBASELIBS)
Index: trunk/SophyaLib/BuildMgr/Darwin_g++_make.inc
===================================================================
--- trunk/SophyaLib/BuildMgr/Darwin_g++_make.inc	(revision 2909)
+++ trunk/SophyaLib/BuildMgr/Darwin_g++_make.inc	(revision 2910)
@@ -45,5 +45,9 @@
 LIBFORT = 
 
-# --- Chemin pour l'ensemble les librairies SOPHYA , +ExtLibs, +PI
+# --- Chemin pour l ensemble les librairies SOPHYA , +ExtLibs, +PI
+SOPHYALIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST)  $(SOPBASELIBS)
+SOPHYAEXTLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPEXTLIBS) $(SOPBASELIBS)
+SOPHYAALLLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPPILIBLIST) $(PILIBS) $(SOPEXTLIBS) $(SOPBASELIBS)
+
 SOPHYASLBLIST = -L$(SOPHYASLBP) -lsophya  $(SOPBASELIBS)
 SOPHYAEXTSLBLIST = -L$(SOPHYASLBP) -lextsophya -lsophya $(SOPEXTLIBS) $(SOPBASELIBS)
Index: trunk/SophyaLib/BuildMgr/IRIX64_CC_make.inc
===================================================================
--- trunk/SophyaLib/BuildMgr/IRIX64_CC_make.inc	(revision 2909)
+++ trunk/SophyaLib/BuildMgr/IRIX64_CC_make.inc	(revision 2910)
@@ -45,4 +45,8 @@
 
 # --- Chemin pour l ensemble les librairies SOPHYA , +ExtLibs, +PI
+SOPHYALIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST)  $(SOPBASELIBS)
+SOPHYAEXTLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPEXTLIBS) $(SOPBASELIBS)
+SOPHYAALLLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPPILIBLIST) $(PILIBS) $(SOPEXTLIBS) $(SOPBASELIBS)
+
 SOPHYASLBLIST = -L$(SOPHYASLBP) -lsophya  $(SOPBASELIBS)
 SOPHYAEXTSLBLIST = -L$(SOPHYASLBP) -lextsophya -lsophya $(SOPEXTLIBS) $(SOPBASELIBS)
Index: trunk/SophyaLib/BuildMgr/Linux_g++_make.inc
===================================================================
--- trunk/SophyaLib/BuildMgr/Linux_g++_make.inc	(revision 2909)
+++ trunk/SophyaLib/BuildMgr/Linux_g++_make.inc	(revision 2910)
@@ -43,4 +43,8 @@
 
 # --- Chemin pour l ensemble les librairies SOPHYA , +ExtLibs, +PI
+SOPHYALIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST)  $(SOPBASELIBS)
+SOPHYAEXTLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPEXTLIBS) $(SOPBASELIBS)
+SOPHYAALLLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPPILIBLIST) $(PILIBS) $(SOPEXTLIBS) $(SOPBASELIBS)
+
 SOPHYASLBLIST = -L$(SOPHYASLBP) -lsophya  $(SOPBASELIBS)
 SOPHYAEXTSLBLIST = -L$(SOPHYASLBP) -lextsophya -lsophya $(SOPEXTLIBS) $(SOPBASELIBS)
Index: trunk/SophyaLib/BuildMgr/Linux_icc_make.inc
===================================================================
--- trunk/SophyaLib/BuildMgr/Linux_icc_make.inc	(revision 2909)
+++ trunk/SophyaLib/BuildMgr/Linux_icc_make.inc	(revision 2910)
@@ -44,4 +44,8 @@
 
 # --- Chemin pour l ensemble les librairies SOPHYA , +ExtLibs, +PI
+SOPHYALIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST)  $(SOPBASELIBS)
+SOPHYAEXTLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPEXTLIBS) $(SOPBASELIBS)
+SOPHYAALLLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPPILIBLIST) $(PILIBS) $(SOPEXTLIBS) $(SOPBASELIBS)
+
 SOPHYASLBLIST = -L$(SOPHYASLBP) -lsophya  $(SOPBASELIBS)
 SOPHYAEXTSLBLIST = -L$(SOPHYASLBP) -lextsophya -lsophya $(SOPEXTLIBS) $(SOPBASELIBS)
Index: trunk/SophyaLib/BuildMgr/OSF1_cxx_make.inc
===================================================================
--- trunk/SophyaLib/BuildMgr/OSF1_cxx_make.inc	(revision 2909)
+++ trunk/SophyaLib/BuildMgr/OSF1_cxx_make.inc	(revision 2910)
@@ -43,4 +43,8 @@
 
 # --- Chemin pour l ensemble les librairies SOPHYA , +ExtLibs, +PI
+SOPHYALIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST)  $(SOPBASELIBS)
+SOPHYAEXTLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPEXTLIBS) $(SOPBASELIBS)
+SOPHYAALLLIBLIST = -L$(SOPHYALIBP) $(SOPMODLIBLIST) $(SOPPILIBLIST) $(PILIBS) $(SOPEXTLIBS) $(SOPBASELIBS)
+
 SOPHYASLBLIST = -L$(SOPHYASLBP) -lsophya  $(SOPBASELIBS)
 SOPHYAEXTSLBLIST = -L$(SOPHYASLBP) -lextsophya -lsophya $(SOPEXTLIBS) $(SOPBASELIBS)
Index: trunk/SophyaLib/BuildMgr/configure
===================================================================
--- trunk/SophyaLib/BuildMgr/configure	(revision 2909)
+++ trunk/SophyaLib/BuildMgr/configure	(revision 2910)
@@ -7,6 +7,11 @@
 #----------------------------------------------------------------------
 #### liste des modules
+set SOPMODOK = ( 1 1 1 1 1 1 1 1 1 )
 set SOPMOD = ( BaseTools SysTools SUtils TArray NTools HiStats SkyMap Samba SkyT )
+set ALLSOPLIBS = ( '-lBaseTools' '-lSysTools' '-lSUtils' '-lTArray' '-lNTools' '-lHiStats' '-lSkyMap' '-lSamba' '-lSkyT' )
+
+set SOPPIOK = ( 1 1 1 )
 set SOPPI = ( PI PIext PIGcont )
+set ALLPILIBS = ( '-lPI' '-lPIext' '-lPIGcont' )
 
 set SOPEXT     = ( FitsIOServer  IFFTW  LinAlg  XAstroPack  MinuitAdapt )
@@ -231,5 +236,5 @@
 #### liens des librairies externes
 echo " "
-echo ">>>>>> 4/  External libraries "
+echo ">>>>>> 4.1/  External libraries "
 set fpath = $TMPDIR/fpath
 rm -f $fpath; touch $fpath
@@ -264,4 +269,36 @@
 
 #----------------------------------------------------------------------
+#### Identification des librairies archives Sophya
+echo " "
+echo ">>>>>> 4.2/  Sophya libraries archives "
+set sopmodlib
+set i = 0
+while ( $i < $#SOPMOD )
+  @ i += 1
+  if( $SOPMODOK[$i] <= 0 ) continue
+  if( -d ../$SOPMOD[$i] ) then
+    set sopmodlib = ( $sopmodlib $ALLSOPLIBS[$i] )
+  else
+    echo "WARNING: module "$SOPMOD[$i]" not found"
+  endif
+end
+echo sopmodlib= $sopmodlib
+
+echo " "
+echo ">>>>>> 4.3/  PI-Sophya libraries archives "
+set soppilib
+set i = 0
+while ( $i < $#SOPPI )
+  @ i += 1
+  if( $SOPPIOK[$i] <= 0 ) continue
+  if( -d ../$SOPPI[$i] ) then
+    set soppilib = ( $soppilib $ALLPILIBS[$i] )
+  else
+    echo "WARNING: module "$SOPPI[$i]" not found"
+  endif
+end
+echo soppilib= $soppilib
+
+#----------------------------------------------------------------------
 #### Generation de sophyamake.inc
 #  On le cree dans le repertoire temporaire d'abord 
@@ -286,7 +323,15 @@
 
 echo " " >> $mfile 
+echo "# module libraries  " >> $mfile
+echo "SOPMODLIBLIST = $sopmodlib" >> $mfile
+
+echo " " >> $mfile 
 echo "# External libraries PATH  " >> $mfile
 echo "SOPEXTLIBP = $extlibpath"  >> $mfile
 echo "SOPEXTLIBLIST = $extliblib" >> $mfile
+
+echo " " >> $mfile 
+echo "# PI libraries  " >> $mfile
+echo "SOPPILIBLIST = $soppilib" >> $mfile
 
 echo " " >> $mfile 