Index: trunk/SophyaLib/Manual/modifs.tex
===================================================================
--- trunk/SophyaLib/Manual/modifs.tex	(revision 2910)
+++ trunk/SophyaLib/Manual/modifs.tex	(revision 2911)
@@ -43,4 +43,5 @@
 V = 1.7  &   \hspace{10mm}  &   Septembre 2003 \\
 V = 1.9  &   \hspace{10mm}  &   Juin 2005 - SANS tag CVS \\
+V = 1.9xx  &   \hspace{10mm}  &  en cours (09/2005 ...) \\
 
 \end{tabular}
@@ -71,5 +72,5 @@
 2/ Prise en compte du type TimeStamp dans MuTyV (sous forme de double en interne) \\
 3/ Adaptation DVList a modifs MuTyV (typ TimeStamp) et R/W PPersist \\
-4/ Gestion format YYYY-MM-DDThh:mm:ss par TimeStamp
+4/ Gestion format YYYY-MM-DDThh:mm:ss par TimeStamp \\
 5/ Gestionnaire PPersist pour TimeStamp
 %
@@ -132,5 +133,11 @@
 \section{TArray}
 \begin{itemize}
-\item Optimisation de la multiplication matricielle (CMV) - Extrait du 
+
+\item[\rond] Janvier 2006  \\
+- Ajout de la methode BaseArray::ValueAtPositionDB() pour corriger un gros bug au 
+niveau de la conversion de type (r\_4 r\_8 ...) des tableaux \\
+- Compil avec g++ 4 : ajouts fichiers declarations privees tmatrix\_tsnl.h tvector\_tsnl.h 
+
+\item[\rond] Optimisation de la multiplication matricielle (CMV) - Extrait du 
 message (from CMV) du 30 Juillet 2004: \\
 \begin{verbatim}
@@ -188,9 +195,9 @@
 \end{verbatim}
 
-\item Optimisation operations diverses, en particulier \\
+\item[\rond] Optimisation operations diverses, en particulier \\
 1) Remplacement des methodes Add/Sub/Mul/DivElt(a) par
    Add/Sub/Mul/DivElt(TArray a, TArray res) \\
 2)  Operateurs += -= A+B A-B TArray et TMatrix/TVecteur modifies en consequence
-\item Extrait de {\tt cvs log tarray.cc } 
+\item[\rond] Extrait de {\tt cvs log tarray.cc } 
 {\small \begin{verbatim}
 ----------------------------
@@ -210,5 +217,5 @@
 \end{verbatim} }
 
-\item Extrait de {\tt cvs log tarray.cc } 
+\item[\rond] Extrait de {\tt cvs log tarray.cc } 
 {\small \begin{verbatim}
 ----------------------------
@@ -302,15 +309,6 @@
 (les operateurs habituel $<<$ et $>>$ sur PIn/OutPersist sont definies)
 
-Actuellement, les colonnes peuvent etre de type \\
-{\tt int\_4  ,  int\_8  ,  r\_4  ,  r\_8  ,  string } \\
-On pourra ajouter apres  les types suivants : \\
-{\tt complex<r\_4>  ,   complex<r\_8>  , TimeStamp }
- 
-Dans BaseDataTable, il reste a remplir la methode
-{\tt BaseDataTable ::FillFromASCIIFile(string const \& fn) } \\
-{\tt BaseDataTable :: Print(int num, int nmax=1) const  }
-(on peut utiliser { \tt LineToString(sa\_size\_t n) const }
-
-Par contre, les merges et copie sont prevues, 
+
+Les merges et copie sont prevues, 
 on doit en principe pouvoir ecrire par exemple:
 \begin{verbatim}
@@ -322,16 +320,7 @@
 \end{verbatim}
 
-On peut aussi ajouter des methodes d'acces aux variables membres pour enrichier l'interface.
-
-{\bf PLUS IMPORTANT : } \\
-Il reste a ecrire la classe FITS\_BaseDataTable ou FITS\_DataTable 
-pour I/O sur fichiers FITS - j'ai regarde {\tt FITS\_XNTuple} qu'on pourra simplifier enormement
-et que devrait etre assez rapide. 
-Il faut aussi faire une classe {\tt SwFITSDataTable}, en recopiant pas mal de chose ds la classe
-{\tt SwPPFDataTable} - On pourrait peut-etre avoir une classe intermediaire qui regroupe
-tout ce qui est commun a {\tt SwFITSDataTable et SwPPFDataTable} , mais a voir.
-L'element cle sera le codage de {\tt FITSDataSwapper<T>}  qui implemente 
-les deux methodes de {\tt DataSwapperInterface<T>} - le reste devrait etre du copier/coller
-essentiellement. 
+{\it On pourra aussi ajouter des methodes d'acces aux variables 
+membres pour enrichier l'interface. }
+
 
 {\bf DataTable cote PIAPP :} \\ 
@@ -372,5 +361,5 @@
 \section{SkyMap , Samba }
 \subsection{Tests et vrifications des polynomes de Legendre} 
---> CMV 
+CMV ???
 
 \subsection{SphereECP} 
@@ -712,4 +701,6 @@
 (Juillet 2004 / cmv , Fvrier 2005 / Reza)
 \begin{itemize}
+\item[\rond] Ajout lancement d'exception sur renvoi de code d'erreur par lapack 
+(desactivable par flag au niveau du constructeur de la classe serveur) 
 \item[\rond] Introduction de l'interface Lapack d'inversion des matrices symetriques (21/7/2004)
 \item[\rond]  Introduction de l'interface Lapack de recherche de valeurs et vecteurs propres
@@ -725,5 +716,5 @@
 
 \section{IFFTW} 
-Correction du bug dans le cas de FFT-1D Backward(complex -> reel) 
+Nov 2005 : Correction du bug dans le cas de FFT-1D Backward(complex -> reel) 
 in(1).imag() pouvait etre ecrase.
 
@@ -732,5 +723,5 @@
 \begin{itemize}
 \item[\rond] {\bf  PIImageNavigator } \\
-Ajout de la classe {\tt PIImageNavigator } permmettant de visualiser une image 
+Ajout de la classe {\tt PIImageNavigator } permettant de visualiser une image 
 avec ses propres widget zoom / global view et colormap. (Fevrier 2005) \\
 Commande {\tt imagnav} ajoute ds piapp/baseexcute.cc . \\
@@ -784,5 +775,5 @@
 \subsection{ Trace des axes (11 Mars 2004)}
     Ajouter la possibilite de specifier l'origine (le point de croisement des axes)
-lorsque les axes ne sont pas de type 'box' - classes PIAxes et PIElDrawer.
+lorsque les axes ne sont pas de type 'box' - classes PIAxes et PIElDrawer.  FAIT
 
 \subsection{ Selection graphique (souris) du drawer actif (11 Mars 2004)}
@@ -1002,6 +993,8 @@
 
 \section{Mgr} 
-{\large Avril-Mai 2005 : Basculement vers la nouvelle version de scripts 
-de gestion du code (module {\bf BuildMgr/ } ) } 
+{\Large Avril-Mai 2005 : Basculement vers la nouvelle version de scripts 
+de gestion du code (module {\bf BuildMgr/ } ) 
+On n'a plus a se preoccuper des indications de cette section 
+} 
 
 \subsection{Variables d'environnement SOPHYAxxx (17/9/2003)  } 
@@ -1010,60 +1003,5 @@
 
 \subsection{Modifs Makefile - Message du 3 Mars 2004 }
-\begin{verbatim}
-Pour Les makefiles SOPHYA, je n'ai pas encore regarde ton makefile.h
-modifie.
-Voila qques propositions :
-il y aura qu'une seule variable d'environnement :  (SOPHYAROOT ou
-SOPHYARACINE) par exemple
-$SOPHYAROOT/Include
-           /Include/FitsIO/ FFTW/  (etc...) pour les .h extlibs
-           /Libs
-           /ShLibs
-           /Exec
-           /Objs
-Un fichier Makefile.h ds $SOPHYAROOT/Include
-contiendra
-#  Section  generale
-SOPHYAROOT =
-SOPHYACXX=
-...
-#  Section compilation
-CC_COMPILER  (nom du compilo cc)
-CXX_COMPILER (   c++)
-CPPFLAGS , (flag du preprocesseur), en particulier
-les -Iincludepath  (chemin pour les includes SOPHYA
-CFLAGS flag de compilation c
-CXXFLAGS flags de compilation c++
-#  Section Link
-LIBPATH -L... -L... (chemin pour les librairies et les lib externes (cfitsio, ...)
-LIBLIST -lm -lcfitsio ... (les librairies)
-
-Ces variables doivent pouvoir etre utilise par la classe CxxCompilerLinker.
-Il faut donc prevoir peut-etre un autre fichier cccpp_flags.h (ou qque chose
-du meme genre) avec la syntaxe C/C++ de chaines de caracteres
-pouvant etre include (par #include) ds cxxcmplnk.cc
-
-le fichier machdefs.h ds $SOPHYAROOT/Include est genere a partir du fichier
-machdefs_mkmf.h actuel (on pourra songer ulterieurement a le casser en
-plusieurs morceaux si necessaire) et contiendra en entete les flags
-qui modifie la generation du code
-
-exemple
-#define Linux
-#define SOPHYA_DEBUG
-....
-
-Dans les fichier Makefile pour chaque module, on abandonnera
-les regles (et repertoire) de compilation par defaut et on aura
-donc:
-INC= $SOPHYAROOT/Include
-OBJ = $SOPHYAROOT/Objs
-LIB=...
-$(OBJ)toto.o : toto.cc $(INC)toto.h $(INC)titi.h ...
-	$CXX $CXXFLAGS -c -o  $(OBJ)toto.o toto.cc
-....
-
-Il faudra voir ensuite pour le makefile de fabrication des shared-libs
-\end{verbatim}
+Modifs effectuees - m nouveau module BuildMgr 
 
 \subsection{ Modifs Makefile - Message du 8 Juillet 2004 }
@@ -1154,5 +1092,11 @@
 
 
-\section{Plan de modifs pour SOPHYA V 2.0 PI/piapp V 4.0 (Septembre 2003) }
+\section{Plan de modifs pour SOPHYA V 2.0 PI/piapp V 4.0 }
+
+{\Large {\bf Dec 2005} : La majorite des modifs ont ete mise en oeuvre - 
+Il faut nettoyer la liste et la transformer en liste pour la version 2.2 ou 2.4 ...} \\
+
+{\bf Plan tabli en septembre 2003 : } 
+
 \subsection{Gestion du code (Mgr/ ) }
 \begin{verbatim}